/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * CMDGADG.H
 *
 * PROGRAMMER : Juan M. Alvarado
 *    VERSION : 00.000
 *    CREATED : 03/06/92
 *   MODIFIED : 07/26/94
 *       TABS : 04 08
 *
 * DESCRIPTION
 *		Command button gadget externs and typedefs.
 *
 * HISTORY
 *
*/

#ifndef CMDGADG_H
#define CMDGADG_H

#include <echidna/platform.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <echidna/etypes.h>
#include <echidna/events.h>
#include <echidna/hitareas.h>
#include <echidna/gadgets.h>
#include <echidna/naming.h>

/**************************** C O N S T A N T S ***************************/

#define cyCGADMin		10
#define cxCGADMin		10

/******************************** T Y P E S *******************************/

typedef BTN CGAD;

/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/

#define DrawCGAD(pbtn, x, y)	DrawBTN ((pbtn), (x), (y))

/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern short FitCGAD (BTN *pbtn);

extern HitArea *phaInitCGADHitArea (
	short x, short y,	
	BTN		*pbtn,		
	GHI		*pghi,		
	PFNGAD	 pfngad,	
	void	*pvData,	
	HitArea *pha, 		
	UWORD	fhaFlags,		
	UWORD	fhaState	
);

#ifdef __cplusplus
}
#endif

#endif /* CMDGADG_H */

