/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * ETYPES.H
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 11/18/93
 *   MODIFIED : 07/26/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Various Types commonly used by our programs
 *
 * HISTORY
 *
*/

#ifndef ETYPES_H
#define ETYPES_H

#include <echidna\platform.h>

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/

typedef unsigned char	UBYTE;
typedef unsigned short	UWORD;
typedef unsigned long	ULONG;

typedef	signed char		SBYTE;
typedef	signed short	SWORD;
typedef	signed long		SLONG;

typedef	signed char		BYTE;
typedef	signed short	WORD;
typedef	signed long		LONG;

typedef int				Boolean;
typedef int				BOOL;

typedef	short			SHORT;
typedef unsigned short	USHORT;

#ifndef TRUE
#define	TRUE			1
#endif

#ifndef	FALSE
#define	FALSE			0
#endif

/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/****************** F U N C T I O N   P R O T O T Y P E S *****************/


#endif /* ETYPES_H */

