/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * SCIC.H
 *
 * PROGRAMMER : Juan M. Alvarado
 *    VERSION : 00.000
 *    CREATED : 02/05/92
 *   MODIFIED : 10/12/93
 *       TABS : 04 08
 *
 * DESCRIPTION
 *		SCaleable ICons typedefs and externs.
 *
 * HISTORY
 *
*/

#ifndef SCIC_H
#define SCIC_H

#include <echidna/platform.h>

#ifdef __cplusplus
extern "C" {
#endif

/**************************** C O N S T A N T S ***************************/

/* Turn USE_H_ARROWS on or off depending on if you program uses horizontal
 * arrows.  Turning it off if you don't use them saves code space.
 */
#define USE_H_ARROWS	1

/* Vertical (up or down) arrow minimum dimensions */
#define cxVArrowMin	3
#define cyVArrowMin	4

/* Horizontal (left or right) arrow minimum dimensions */
#define cxHArrowMin	4
#define cyHArrowMin	3

/******************************** T Y P E S *******************************/


/* These function guarantee to draw an image no bigger than dimensions in
 *	struct passed to it.  They return true if they drew anything.
 */
typedef short (*pfnSCIC)(short x, short y, struct SCIC *pfnscic);
typedef struct SCIC {
	short	cx,cy;		/* width and height */
	pfnSCIC	pfnscic;		/* function that draws image */
} SCIC;	/* Scaled Icon */

/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern short	Draw_SCIC_UpArrow (short x, short y, SCIC *pscic);
extern short	Draw_SCIC_DnArrow (short x, short y, SCIC *pscic);
extern short	Draw_SCIC_LftArrow (short x, short y, SCIC *pscic);
extern short	Draw_SCIC_RgtArrow (short x, short y, SCIC *pscic);
extern short	Draw_SCIC_UpChevron (short x, short y, SCIC *pscic);
extern short	Draw_SCIC_DnChevron (short x, short y, SCIC *pscic);
extern short	Draw_SCIC_DnImpactArrow (short x, short y, SCIC *pscic);

#ifdef __cplusplus
}
#endif

#endif /* SCIC_H */

