/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * SZERROR.H
 *
 * PROGRAMMER : Dan Chang
 *    VERSION : 00.000
 *    CREATED : 07/31/93
 *   MODIFIED : 09/28/94
 *       TABS : 04 07
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Consolidated error messages.
 *		Someday, all BEIFFLIB error message will be here...
 *
 * HISTORY
 *		07/31/93 Saturday (dcc) - created.
 *
*/

#ifndef SZERROR_H
#define SZERROR_H


/**************************** C O N S T A N T S ***************************/

/* These constants are "local"; they are used only to build "global" constants. */

#define szCMAP						"\nCreatePalette:"
#define szILBM						"\nReadILBM:"
#define szPBM						"\nReadPBM:"

#define szILBMBODY				"\nReadILBMBODY:"
#define szPBMBODY					"\nReadPBMBODY:"

#define szBadPacked				"Bad unpacking data"
#define szCantOpen				"Couldn't open '%s'"
#define szCantRead				"Error reading '%s'"
#define szDataMismatch			"ILBM form size and data do not match"
#define szOOMILBMInfo			"OOM ILBMInfo"
#define szOOMWorkBuf				"OOM work buffer"
#define szShortFORM				"Missing Bytes in FORM"
#define szUnknownComp			"Unknown compression type %d"

/* These are the "global" constants that are used */

#define szerrCCantOpen			szCMAP szCantOpen
#define szerrCCantRead			szCMAP szCantRead
#define szerrCDataMismatch		szCMAP szDataMismatch
#define szerrCOOMILBMInfo		szCMAP szOOMILBMInfo

#define szerrIBadPacked			szILBMBODY szBadPacked
#define szerrICantOpen			"\nCreatePlanesOPixels:" szCantOpen
#define szerrIDataMismatch		szILBM szDataMismatch
#define szerrIOOMILBMInfo		szILBM szOOMILBMInfo
#define szerrIOOMWorkBuf		szILBMBODY szOOMWorkBuf
#define szerrIShortFORM			szILBMBODY szShortFORM
#define szerrIUnknownComp		(szILBMBODY szUnknownComp)

#define szerrOOMCRNG				"\nReadCRNG:OOM CrngNode"
#define szerrOOMMasks			szILBMBODY "OOM masks"
#define szerrOOMPalette			"\nReadCMAP:OOM color/palette"
#define szerrOOMPlanes			szILBMBODY "OOM planes"
#define szerrOOXMBitPlanes		szPBMBODY "OOXM bit planes"
#define szerrOOXMPixel			"\nAllocBigByteMap:OOXM pixel"
#define szerrOOXMPlanes			"\nAllocBigByteMap:OOXM planes"
#define szerrOOMPixBuf			"\nReadILBMBODY:OOM pixel buffer"
#define szerrOOMPixRow			"\nAllocBigByteMap:OOM pixel row pointers"
#define szerrOOMRowBuf			"\nAllocBigByteMap:OOM row buffer"
#define szerrOOMTempBitPlanes	"\nReadPBMBODY:OOM temp bit planes"
#define szerrOOMTempPlane		"\nReadILBMBODY:OOM temp plane"

#define szerrPBadPacked			szPBMBODY szBadPacked
#define szerrPCantOpen			"\nCreateBlockOPixels:" szCantOpen
#define szerrPDataMismatch		szPBM szDataMismatch
#define szerrPOOMILBMInfo		szPBM szOOMILBMInfo
#define szerrPOOMWorkBuf		szPBMBODY szOOMWorkBuf
#define szerrPShortFORM			szPBMBODY szShortFORM
#define szerrPUnknownComp		szPBMBODY szUnknownComp


#endif /* SZERROR_H */

