;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** CGFX.asm
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 12/15/89
;**   MODIFIED : 01/18/92
;**       TABS : 09 15 40 44
;**
;**    	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**    Various Graphics Routines for CGA mode.
;**    
;** HISTORY
;**
;**

	IDEAL

;********************************* EXTERNS *********************************
	EXTRN _CGA_OpenGraphics:PROC
	EXTRN _CGA_CloseGraphics:PROC
	EXTRN _CGA_ConvertShape:PROC
	EXTRN _CGA_FreeShape:PROC
	EXTRN _CGA_DrawShapeNoTrans:PROC
	EXTRN _CGA_DrawRect:PROC
	EXTRN _CGA_GetGShapeLoadBuf:PROC
	EXTRN _CGA_UsePaletteN:PROC
	EXTRN _CGA_FadeToPaletteN:PROC
	EXTRN _CGA_UseColorCycleSet:PROC   
	EXTRN _CGA_FadeToColorCycleSet:PROC
	EXTRN _CGA_UsePaintBoxN:PROC
	EXTRN _CGA_FadeToPaintBoxN:PROC
	EXTRN _CGA_OpenPainter:PROC
	EXTRN _CGA_ClosePainter:PROC       

;********************************* SEGMENT *********************************
	INCLUDE "GFXMDL.inc"
	WSEG	GGFX_TEXT

;**************************** GLOBAL VARIABLES *****************************
	PUBLIC _CGARoutineTable
	PUBLIC _CGADataTable

;***************************** PUBLIC ROUTINES *****************************
	PUBLIC _CGA_ASMOpenGraphics
	PUBLIC _CGA_ASMCloseGraphics

;******************************** VARIABLES ********************************
CGrSeg		 DW ?
CPenColor	 DB ?
CPaperColor	 DB ?
CWorkBuffer	 DW 0
CBackBuffer	 DW 0
CDisplayBuffer DW 0B800h
_CGAEvenPatTbl DB 000h ; 0
		DB 055h ; 1
		DB 0AAh ; 2
		DB 0FFh ; 3
		DB 011h ; 4
		DB 022h ; 5
		DB 033h ; 6
		DB 066h ; 7
		DB 077h ; 8
		DB 0BBh ; 9
		DB 000h ;10
		DB 000h ;11
		DB 000h ;12
		DB 000h ;13
		DB 000h ;14
		DB 000h ;15
		DB 240 DUP (?)
_CGAOddPatTbl	DB 000h ; 0
		DB 055h ; 1
		DB 0AAh ; 2
		DB 0FFh ; 3
		DB 044h ; 4
		DB 088h ; 5
		DB 0CCh ; 6
		DB 099h ; 7
		DB 0DDh ; 8
		DB 0EEh ; 9
		DB 000h ;10
		DB 000h ;11
		DB 000h ;12
		DB 000h ;13
		DB 000h ;14
		DB 000h ;15
		DB 240 DUP (?)

	MACRO Rptr Routine

	DW	OFFSET Routine, SEG Routine

	ENDM

_CGADataTable:
	RPtr	CPenColor
	RPtr	CPaperColor
	Rptr	CGrSeg
	RPtr	CWorkBuffer
	RPtr	CBackBuffer
	RPtr	CDisplayBuffer
	RPtr	_CGAEvenPatTbl
	RPtr	_CGAOddPatTbl

_CGARoutineTable:
	Rptr	_CGA_OpenGraphics
	Rptr	_CGA_CloseGraphics
	Rptr	_CGA_DrawPixel
	Rptr	_CGA_DrawRect
	Rptr	_CGA_ClearScreen
	Rptr	_CGA_DrawShape
	Rptr	_CGA_Restore
	Rptr	_CGA_UnRestore
	Rptr	_CGA_ShowRect
	Rptr	_CGA_ConvertShape
	Rptr	_CGA_FreeShape
	Rptr	_CGA_DrawShapeNoTrans
	Rptr	_CGA_GetGShapeLoadBuf
	Rptr	_CGA_UsePaletteN
	Rptr	_CGA_FadeToPaletteN
	Rptr	_CGA_UseColorCycleSet   
	Rptr	_CGA_FadeToColorCycleSet
	Rptr	_CGA_UsePaintBoxN
	Rptr	_CGA_FadeToPaintBoxN
	Rptr	_CGA_OpenPainter
	Rptr	_CGA_ClosePainter       
	Rptr	_CGA_SetClipArea       
	Rptr	0

	LABEL LineSt WORD	; Lookup table for line start adresses
x       =     0
        REPT 100

        dw  x*80+0000h
        dw  x*80+2000h

x       =   x + 1
        ENDM


PMasks	DB	0C0h
	DB	030h
	DB	00Ch
	DB	003h

;=====================================================================
;**
;** _CGA_ASMCloseGraphics
;**
;** PURPOSE
;**	Free CGA resources and return to text mode.
;**
;** INPUT
;**	NONE
;**
;** REGISTERS USED
;**	AX,BX,ES
;**
;** EFFECTS
;**	OBuffer and BBuffer 64000 bytes * 2 freed.
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	MPROC _CGA_ASMCloseGraphics
	MPROC _CGA_ASMCloseGraphics

	mov	ax,03h	; Return to Text mode
	int	10h

	IF 0
OpenCleanup:
	mov	ax,[CS:CBackBuffer]	; If BBuffer was allocated
	cmp	ax,0	; deallocate it.
	jz	@@no_bbuf
	mov	es,ax
	mov	ah,049h
	int	21h

@@no_bbuf:
	mov	ax,[CS:CWorkBuffer]	; If OBBuffer was allocated
	cmp	ax,0	; deallocate it.
	jz	@@no_obuf
	mov	es,ax
	mov	ah,049h
	int	21h
	ENDIF

@@no_obuf:
	mov	ax,0	; Return 0 for OpenGraphics Failure.
	ret
	ENDP
	ENDP

;=====================================================================
;**
;** CGA_ASMOpenGraphics
;** _CGA_ASMOpenGraphics
;**
;** PURPOSE
;**	Initialize CGA Graphics Routines.
;**
;** INPUT
;**	NONE
;**
;** REGISTERS USED
;**	AX, BX, ES
;**
;** EFFECTS
;**	Allocates 2 64000 byte buffers and enters CGA mode
;**
;** RETURN VALUE
;**	AX = 0  failed
;**	   = !0 success
;**
;** LIMITS/BUGS
;**		
;**
;** HISTORY
;**		
;**

	MPROC _CGA_ASMOpenGraphics
	MPROC CGA_ASMOpenGraphics

	IF 0
	mov	ah,048h	; Allocate 64000 bytes on a
	mov	bx,4000	; paragraph boundry for OBuffer.
	int	21h
	jc	OpenCleanup	; -=>Failed
	mov	[CS:CWorkBuffer],ax	;

	mov	ah,048h	; Allocate 64000 bytes on a
	mov	bx,4000	; paragraph boundry for OBuffer.
	int	21h
	jc	OpenCleanup	; -=>Failed
	mov	[CS:CBackBuffer],ax	;
	ENDIF

	mov	ax,04h	; Start CGA mode.
	int	10h

	ret
	ENDP
	ENDP


;=====================================================================
;**
;** CGA_DrawPixel
;**
;** PURPOSE
;**	Draw one Pixel on the current work page.
;**
;** INPUT
;**	AX       = xpos
;**	BX       = ypos
;**	PenColor = color
;**
;** REGISTERS USED
;**	AX, BX, CX, DX, DI, ES
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	MPROC CGA_DrawPixel

	mov	cl,bl	; Save Ypos
	shl	bx,1
	mov	di,[CS:LineSt+BX]	; Get Starting address of y row
	mov	bx,ax
	shr	bx,1
	shr	bx,1
	add	di,bx	; add x column.
	and	al,03h	; get pixel num (0-3);
	mov	bl,al
	xor	bh,bh
	mov	al,[CS:PMasks+bx]

	mov	bx,[CS:CGrSeg]	; Get Segment of current page.
	mov	es,bx

	xor	bh,bh
	mov	bl,[CS:CPenColor]	; Get Pen Color.
	test	cl,01h	; odd or even line?
	jnz	@@oddline
	mov	dl,[CS:_CGAEvenPatTbl+bx]
	jmp	short @@gotit
@@oddline:
	mov	dl,[CS:_CGAOddPatTbl+bx]
@@gotit:
	mov	bl,dl	; Get old screen data.
	xor	bl,[es:di]
	and	bl,al
	xor	bl,[es:di]
	mov	[es:di],bl

	ret

	ENDP


;=====================================================================
;**
;** _CGA_DrawPixel
;**
;** PURPOSE
;**	C Glue to CGA_DrawPixel
;**
;** INPUT
;**	C parms: CGA_DrawPixel (int x, int y)
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**

	MPROC _CGA_DrawPixel
	ARG  XPOS:WORD, YPOS:WORD

	push	bp
	mov	bp,sp

	push	di

	mov	bx,[YPOS]
	mov	ax,[XPOS]
	call	CGA_DrawPixel

	pop	di

	pop	bp
	ret

	ENDP

;******************************** INCLUDES *********************************
	INCLUDE "CSHAPE.asm"
	INCLUDE "CRESTORE.asm"
	INCLUDE "CRECT.asm"
	INCLUDE "CCLEAR.asm"

	ENDS
	END

