/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * LINE.C
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 12/18/90
 *   MODIFIED : 03/13/95
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		
 *
 * HISTORY
 *		10/10/93 (dcc) - Changed short's to int's to support 32-bit procs.
 *		02/05/95 (dcc) - #include <echidna/line.h> to verify prototypes.
 *
*/

#include <echidna/platform.h>
#include "switches.h"

#include <echidna/graphics.h>
#include <echidna/line.h>				// verify function prototype
#include <echidna/emacros.h>

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/


/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/***************************** R O U T I N E S ****************************/
#if 0
/*********************************************************************
 *
 * DrawLine
 *
 * PURPOSE
 *		
 *
 * INPUT
 *
 *
 * EFFECTS
 *
 *
 * RETURN VALUE
 *
 *
 * HISTORY
 *
 *
 * SEE ALSO
 *
*/
void DrawLine (int OLDX, int OLDY, int NEWX, int NEWY)
{

/*-------------------------------------------------------------------------*/
#if FUNC_NAMES
 CurrentFuncName = "DrawLine";
#endif
#if REQUIRE

#endif
/*-------------------------------------------------------------------------*/

	BeforeGraphics ();
	{
		int	XPOS;
		int	YPOS;
		int	YDIST;
		int	XDIST;
		int	XDIR;
		int	YDIR;
		int	XSTER;
		int	YSTER;
		int	COUNTR;
		int	ENDPT;

		YDIST = NEWY - OLDY;
	 	YDIR = sign (YDIST);
		YDIST =  abs (YDIST);
		XDIST = NEWX - OLDX;
	 	XDIR = sign (XDIST);
		XDIST =  abs (XDIST);

		YSTER = 0;
		XSTER = 0;

		YPOS = OLDY;
		XPOS = OLDX;

		if (XDIST > YDIST) {
			COUNTR = XDIST;
		} else {
			COUNTR = YDIST;
		}

		ENDPT = COUNTR;

		if (COUNTR == XDIST) {
			YSTER = ENDPT >> 1;
			while (COUNTR > 0)  {
				YSTER += YDIST;
				if (YSTER >= ENDPT) {
					YSTER -=  ENDPT;
					YPOS  += YDIR;
				}
				XPOS += XDIR;
				DrawPixel (XPOS, YPOS);
				COUNTR--;
			}
		} else {
			XSTER = ENDPT >> 1;
			while (COUNTR > 0)  {
				YPOS  += YDIR;
				XSTER += XDIST;
				if (XSTER >= ENDPT) {
					XSTER -= ENDPT;
					XPOS  += XDIR;
				}
				DrawPixel (XPOS, YPOS);
				COUNTR--;
			}
		}

	}
	AfterGraphics ();

} /* DrawLine */
#endif
#if 0
/*********************************************************************
 *
 * DrawLine
 *
 * PURPOSE
 *		
 *
 * INPUT
 *
 *
 * EFFECTS
 *
 *
 * RETURN VALUE
 *
 *
 * HISTORY
 *
 *
 * SEE ALSO
 *
*/
void DrawLine (int OLDX, int OLDY, int NEWX, int NEWY)
{

/*-------------------------------------------------------------------------*/
#if FUNC_NAMES
 CurrentFuncName = "DrawLine";
#endif
#if REQUIRE

#endif
/*-------------------------------------------------------------------------*/

	BeforeGraphics ();
	{
		int	XPOS;
		int	YPOS;
		int	YDIST;
		int	XDIST;
		int	XDIR;
		int	YDIR;
		int	XSTER;
		int	YSTER;
		int	COUNTR;
		int	ENDPT;

		YDIST = NEWY - OLDY;
	 	YDIR = sign (YDIST);
		YDIST =  abs (YDIST);
		XDIST = NEWX - OLDX;
	 	XDIR = sign (XDIST);
		XDIST =  abs (XDIST);

		YSTER = 0;
		XSTER = 0;

		YPOS = OLDY;
		XPOS = OLDX;

		if (XDIST > YDIST) {
			COUNTR = XDIST;
		} else {
			COUNTR = YDIST;
		}

		ENDPT = COUNTR;

		if (COUNTR == XDIST) {
			YSTER = ENDPT >> 1;
		} else {
			XSTER = ENDPT >> 1;
		}

		while (COUNTR > 0)  {
			YSTER = YSTER + YDIST;
			if (YSTER >= ENDPT) {
				YSTER = YSTER - ENDPT;
				YPOS  = YPOS + YDIR;
			}
			XSTER = XSTER + XDIST;
			if (XSTER >= ENDPT) {
				XSTER = XSTER - ENDPT;
				XPOS  = XPOS + XDIR;
			}
			DrawPixel (XPOS, YPOS);
			COUNTR--;
		}
	}
	AfterGraphics ();

} /* DrawLine */
#endif
#if 1
/*********************************************************************
 *
 * DrawLine
 *
 * PURPOSE
 *		
 *
 * INPUT
 *
 *
 * EFFECTS
 *
 *
 * RETURN VALUE
 *
 *
 * HISTORY
 *		02/15/94 Tuesday (dcc) - change ( x < x1 ) to ( x != x1) so line can
 *								be drawn in any direction
 *
 * SEE ALSO
 *
*/
void DrawLine (int x0, int y0, int x1, int y1)
{

/*-------------------------------------------------------------------------*/
#if FUNC_NAMES
 CurrentFuncName = "DrawLine";
#endif
#if REQUIRE

#endif
/*-------------------------------------------------------------------------*/

	BeforeGraphics ();
	{
		int	dx;
		int	dy;
		int	xdir;
		int	ydir;
		int	incrE;
		int	incrNE;
		int	d;
		int	x;
		int	y;

		dx   = x1 - x0;
		xdir = sign (dx);
		dx   = abs (dx);

		dy   = y1 - y0;
		ydir = sign (dy);
		dy   = abs (dy);

		if (dx > dy) {
			d  = dy + dy - dx;

			incrE  = dy + dy;
			incrNE = 2 * (dy - dx);

			x = x0;
			y = y0;

			while ( x != x1 ) {
				if (d <= 0) {
					d += incrE;
					x += xdir;
				} else {
					d += incrNE;
					x += xdir;
					y += ydir;
				}
				DrawPixel (x, y);
			}
		} else {
			d  = dx + dx - dy;

			incrE  = dx + dx;
			incrNE = 2 * (dx - dy);

			x = x0;
			y = y0;

			while ( y != y1 ) {
				if (d <= 0) {
					d += incrE;
					y += ydir;
				} else {
					d += incrNE;
					y += ydir;
					x += xdir;
				}
				DrawPixel (x, y);
			}
		}
	}
	AfterGraphics ();

} /* DrawLine */
#endif

