;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** MGFX.asm
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 12/15/89
;**   MODIFIED : 04/01/92
;**       TABS : 09 15 40 44
;**
;**    	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**    Various Graphics Routines for MCGA mode.
;**    
;** HISTORY
;**
;**

	IDEAL

	INCLUDE "GSWITCHS.inc"

;********************************* EXTERNS *********************************
	EXTRN _MCGA_OpenGraphics:PROC
	EXTRN _MCGA_CloseGraphics:PROC
	EXTRN _MCGA_ConvertShape:PROC
	EXTRN _MCGA_FreeShape:PROC
	EXTRN _MCGA_DrawShapeNoTrans:PROC
	EXTRN _MCGA_DrawRect:PROC
	EXTRN _MCGA_GetGShapeLoadBuf:PROC
	
     	if USE_GRAFX
	EXTRN _MCGA_ClippedXORRect:PROC
	EXTRN _MCGA_ClippedCopyRect:PROC
	EXTRN _MCGA_ReallyClippedCopyRect:PROC
	EXTRN _MCGA_DrawShape:PROC
	EXTRN	_MCGA_SaveArea:PROC
	EXTRN _MCGA_RestoreArea:PROC

	else
	EXTRN _MCGA_UsePaletteN:PROC
	EXTRN _MCGA_FadeToPaletteN:PROC
	EXTRN _MCGA_UseColorCycleSet:PROC   
	EXTRN _MCGA_FadeToColorCycleSet:PROC
	EXTRN _MCGA_UsePaintBoxN:PROC
	EXTRN _MCGA_FadeToPaintBoxN:PROC
	EXTRN _MCGA_OpenPainter:PROC
	EXTRN _MCGA_ClosePainter:PROC  
	endif

;********************************* SEGMENT *********************************
	INCLUDE "GFXMDL.inc"
	WSEG	MGFX_TEXT

;**************************** GLOBAL VARIABLES *****************************
	PUBLIC _MCGADataTable
	PUBLIC _MCGARoutineTable

	if USE_GRAFX
	PUBLIC _RemapTable
	PUBLIC _BeforeGraphicsFunc
	PUBLIC _AfterGraphicsFunc
	endif

;***************************** PUBLIC ROUTINES *****************************
	PUBLIC _MCGA_ASMOpenGraphics
	PUBLIC _MCGA_ASMCloseGraphics

;********************************* MACROS **********************************
	MACRO	BeforeGraphics

	if	USE_GRAFX
	call	_RealBeforeGraphics
	endif

	ENDM

	MACRO	AfterGraphics

	if	USE_GRAFX
	call	_RealAfterGraphics
	endif

	ENDM
;******************************** VARIABLES ********************************
MClipLeft	 dw 0
MClipTop	 dw 0
MClipWidth	 dw 320
MClipHeight	 dw 200
MClipRight	 dw 319
MClipBottom	 dw 199
MGrSeg		 DW ?
MPenColor	 DB ?
MPaperColor	 DB ?
MWorkBuffer	 DW 0
MBackBuffer	 DW 0
MDisplayBuffer DW 0A000h

	LABEL	_BeforeGraphicsFunc DWORD
	DW	0
	DW	0
	LABEL	_AfterGraphicsFunc DWORD
	DW	0
	DW	0

	MACRO Rptr Routine

	DW	OFFSET Routine, SEG Routine

	ENDM

_MCGADataTable:
	RPtr	MClipLeft
	RPtr	MClipTop 
	RPtr	MClipWidth
	RPtr	MClipHeight
	RPtr	MClipRight 
	RPtr	MClipBottom
	RPtr	MPenColor
	RPtr	MPaperColor
	RPtr	MGrSeg
	RPtr	MWorkBuffer
	RPtr	MBackBuffer
	RPtr	MDisplayBuffer
	RPtr	0
	RPtr	0

_MCGARoutineTable:
	Rptr	_MCGA_OpenGraphics
	Rptr	_MCGA_CloseGraphics
	Rptr	_MCGA_DrawPixel
	Rptr	_MCGA_DrawRect
	Rptr	_MCGA_ClearScreen
	Rptr	_MCGA_DrawShape
	Rptr	_MCGA_Restore
	Rptr	_MCGA_UnRestore
	Rptr	_MCGA_ShowRect
	Rptr	_MCGA_ConvertShape
	Rptr	_MCGA_FreeShape
	Rptr	_MCGA_DrawShapeNoTrans
	Rptr	_MCGA_GetGShapeLoadBuf
	if USE_GRAFX
	else
	Rptr	_MCGA_UsePaletteN
	Rptr	_MCGA_FadeToPaletteN
	Rptr	_MCGA_UseColorCycleSet   
	Rptr	_MCGA_FadeToColorCycleSet
	Rptr	_MCGA_UsePaintBoxN
	Rptr	_MCGA_FadeToPaintBoxN
	Rptr	_MCGA_OpenPainter
	Rptr	_MCGA_ClosePainter       
	endif
	if USE_GRAFX
	Rptr	_MCGA_ClippedXORRect
	Rptr	_MCGA_ClippedCopyRect
	Rptr	_MCGA_ReallyClippedCopyRect
	Rptr	_MCGA_SaveArea
	Rptr	_MCGA_RestoreArea
	endif
	Rptr	0

	LABEL LineSt  WORD	; Lookup table for line start adresses
i 	=	0
	REPT	200	
	DW	i*320
i	=	i + 1
	ENDM

	if USE_GRAFX
	LABEL _RemapTable BYTE	; RemapTable for colors.
i	=	0
	REPT	256
	DB	i
i	=	i + 1
	ENDM
	endif


;=====================================================================
;**
;** _MCGA_ASMCloseGraphics
;**
;** PURPOSE
;**	Free MCGA resources and return to text mode.
;**
;** INPUT
;**	NONE
;**
;** REGISTERS USED
;**	AX,BX,ES
;**
;** EFFECTS
;**	OBuffer and BBuffer 64000 bytes * 2 freed.
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	MPROC _MCGA_ASMCloseGraphics
	MPROC _MCGA_ASMCloseGraphics

	mov	ax,03h	; Return to Text mode
	int	10h

@@no_obuf:
	mov	ax,0	; Return 0 for OpenGraphics Failure.
	ret
	ENDP
	ENDP

;=====================================================================
;**
;** MCGA_ASMOpenGraphics
;** _MCGA_ASMOpenGraphics
;**
;** PURPOSE
;**	Initialize MCGA Graphics Routines.
;**
;** INPUT
;**	NONE
;**
;** REGISTERS USED
;**	AX, BX, ES
;**
;** EFFECTS
;**	Allocates 2 64000 byte buffers and enters MCGA mode
;**
;** RETURN VALUE
;**	AX = 0  failed
;**	   = !0 success
;**
;** LIMITS/BUGS
;**		
;**
;** HISTORY
;**		
;**

	MPROC _MCGA_ASMOpenGraphics
	MPROC MCGA_ASMOpenGraphics

	mov	ax,013h	; Start MCGA mode.
	int	10h

	ret
	ENDP
	ENDP


	if USE_GRAFX
;=====================================================================
;**
;** _BeforeGraphics
;**
;** PURPOSE
;**	Allow something to always be done before screen memory is
;**	modified.
;**
;** INPUT
;**	
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	PUBLIC _RealBeforeGraphics
	MPROC  _RealBeforeGraphics

	push	bp
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	es
	push	ds

	cmp	[WORD ptr cs:_BeforeGraphicsFunc+2],0
	jz	@@skip
	call	[cs:_BeforeGraphicsFunc]
@@skip:

	pop	ds
	pop	es
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	pop	bp
	ret

	ENDP

;=====================================================================
;**
;** _AfterGraphics
;**
;** PURPOSE
;**	Allow something to always be done After screen memory is
;**	modified.
;**
;** INPUT
;**	
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	PUBLIC _RealAfterGraphics
	MPROC  _RealAfterGraphics

	push	bp
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	es
	push	ds


	cmp	[WORD ptr cs:_AfterGraphicsFunc+2],0
	jz	@@skip
	call	[cs:_AfterGraphicsFunc]
@@skip:

	pop	ds
	pop	es
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	pop	bp
	ret

	ENDP
	endif

;=====================================================================
;**
;** MCGA_DrawPixel
;**
;** PURPOSE
;**	Draw one Pixel on the current work page.
;**
;** INPUT
;**	AX       = xpos
;**	BX       = ypos
;**	PenColor = color
;**
;** REGISTERS USED
;**	AX, BX, DI, ES
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	MPROC MCGA_DrawPixel

	BeforeGraphics

	shl	bx,1
	mov	di,[CS:LineSt+BX]	; Get Starting address of y row
	add	di,ax	; add x column.

	mov	ax,[CS:MGrSeg]	; Get Segment of current page.
	mov	es,ax

	if	USE_GRAFX
	mov	bl,[CS:MPenColor]	; Get Pen Color.
	sub	bh,bh	; Look up thru RemapTable
	mov	al,[CS:_RemapTable+bx]
	else
	mov	al,[CS:MPenColor]
	inc	al
	endif

	stosb
	AfterGraphics

	ret

	ENDP


;=====================================================================
;**
;** _MCGA_DrawPixel
;**
;** PURPOSE
;**	C Glue to MCGA_DrawPixel
;**
;** INPUT
;**	C parms: MCGA_DrawPixel (int x, int y)
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**

	MPROC _MCGA_DrawPixel
	ARG  XPOS:WORD, YPOS:WORD

	push	bp
	mov	bp,sp

	push	di

	mov	bx,[YPOS]
	mov	ax,[XPOS]
	call	MCGA_DrawPixel

	pop	di

	pop	bp
	ret

	ENDP

;******************************** INCLUDES *********************************
	INCLUDE "MRESTORE.asm"
	INCLUDE "MRECT.asm"
	INCLUDE "MCLEAR.asm"
	if USE_GRAFX
	else
	INCLUDE "MWRTCRNG.asm"
	INCLUDE "MSHAPE.asm"
	endif

	ENDS
	END

