/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * SIZEDEFS.h
 *
 * PROGRAMMER : Gregg A. Tavares 
 *    VERSION : 00.000
 *    CREATED : 08/03/89 
 *   MODIFIED : 07/27/94
 *       TABS : 04 07
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *    Standard size definitions used in most of my programs.
 *
 * HISTORY
 *
*/
#ifndef SIZEDEFS_H
#define SIZEDEFS_H

/*
** DEPTH is the number of bitplane for your display.
** 1 = 2  colors
** 2 = 4  colors
** 3 = 8  colors
** 4 = 16 colors
** 5 = 32 colors
** 6 = 64 colors [Extra-HalfBrite] or
**     4096 colors [Hold-And-Modify]
*/
#define DEPTH	5

/*
** WIDTH is the width of the display in pixels.  If you set it to more than
** 320 you must set the HIRES bit of the MODES define.
*/
#define WIDTH	320

/*
** HEIGHT is the height of the display in pixels.  If you set to to more than
** 200 you must set the LACE bit of the MODES define.
*/
#define HEIGHT	200

/*
** MODES is used to define the display modes you want.  Valid flags are
**   HIRES -> 640 across
**   LACE  -> 400 down
**   HAM   -> Hold-And-Modify
**   EXTRA_HALFBRITE -> Extra-HalfBrite mode.
**   NULL  -> No special modes.
*/
#define MODES	NULL

#endif /* SIZEDEFS_H */

