;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 


; Translation of Juan Alvarado's C routine by Dan Chang.
; One day before Tax Day, 1991.

	IDEAL
	PUBLIC	_WriteColorRanges

	PUBLIC	_ActivationFlag
	PUBLIC	_CopyRanges

	WSEG	MGFX_TEXT

; Note: if you change CopyRangeType structure,
; please fix SIZEOF_CopyRange constant below!

	STRUC	CopyRangeType
NumColors	dw	?
ColorPtr	dd	?
ColorReg	dw	?
	ENDS

SIZEOF_CopyRange	equ	(8)

	EVEN

_ActivationFlag	dw	?		;do work or not
_CopyRanges	dd	?		;pointer to data to copy

	MPROC	_WriteColorRanges

	mov	ax, [cs:_ActivationFlag]
	or	ax, ax
	jz	@@OutDone		;=> nothing to do!

	push	ds
	push	si

	cld
	mov	dx, 03C9h
	les	bx, [cs:_CopyRanges]
@@forLoop:
	mov	cx, [es:bx+CopyRangeType.NumColors]
	or	cx, cx
	jz	@@exit			;=> no colors to copy

	mov	al, [byte ptr es:bx+CopyRangeType.ColorReg]
	inc	al			;address to write to

	lds	si, [es:bx+CopyRangeType.ColorPtr]	;-> 1st byte to write

	dec	dx	;= 03C8h
	out	dx, al

	inc	dx	;= 03C9h
@@writeLoop:
	lodsb
	out	dx, al
	lodsb
	out	dx, al
	lodsb
	out	dx, al
	loop	@@writeLoop

	add	bx, SIZEOF_CopyRange		;do next CopyRange
	jmp	@@forLoop
@@exit:
	mov	[cs:_ActivationFlag], cx	;= 0

	pop	si
	pop	ds
@@OutDone:
	ret
	ENDP

	ENDS
	END

